#!/usr/bin/perl -w
# Example based on code and XML from the Perl XML faq:
# http://perl-xml.sourceforge.net/faq/

use XML::Checker::Parser;
use Data::Dumper;

if ($#ARGV != 0) {
    print STDERR "Usage: $0 <xmlfile>\n";
    exit(-1);
}

$xml_file = $ARGV[0];

my $xmlerror = 0;
sub my_fail
{
    my $code = shift;
    XML::Checker::print_error ($code, @_);
    $xmlerror = 1;
}

my $xp = new XML::Checker::Parser (Style => 'Tree', Handlers => { } );

my @parsed_xml;

eval {
    local $XML::Checker::FAIL = \&my_fail;
    @parsed_xml = $xp->parsefile($xml_file);
};
if ($xmlerror) {
    print "$xml_file failed validation!\n";
} else {
    print Dumper(@parsed_xml);
    print "$xml_file passed validation\n";
}
